﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TheOne.Data;
using TheOne.Diagnostics;
using TheOne.Transactions;

namespace QuickStart.Biz
{
    public class BizComponent : FoxBizBase
    {
        public void Save(List<Dictionary<string, object>> created, 
            List<Dictionary<string, object>> updated, 
            List<Dictionary<string, object>> deleted)
        {
            using (var dac = new DacComponent())
            {
                foreach (var product in deleted)
                {
                    dac.Delete(product);
                }
                foreach (var product in created)
                {
                    dac.Insert(product);
                }
                foreach (var product in updated)
                {
                    dac.Update(product);
                }
            }
        }

        protected override void OnError(Exception ex)
        {
            IFoxLog log = FoxLogManager.GetLogger(this.GetType());
            log.Write(this.GetType().FullName, FoxLogLevel.Error, ex);
        }
    }
}
