﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using TheOne.Diagnostics;
using TheOne.Data;
using TheOne.Data.SqlClient;
using TheOne.Transactions;

namespace QuickStart.Biz
{
    public class DacComponent : FoxDacBase
    {
        public DataSet GetDemoProduct()
        {
            IFoxLog log = FoxLogManager.GetLogger(this.GetType());
            log.Write(FoxLogLevel.Information, "GetDemoProduct 호출됨!");
            return this.DbAccess.ExecuteQueryDataSet("DemoProduct.Get");
        }

        public void Update(IDictionary<string, object> product)
        {
            // 데이터 업데이트 수행
            this.DbAccess.ExecuteQueryNonQuery("DemoProduct.Update", product);
        }

        public void Delete(IDictionary<string, object> product)
        {
            // 데이터 삭제 수행
            this.DbAccess.ExecuteQueryNonQuery("DemoProduct.Delete", product);
        }

        public void Insert(IDictionary<string, object> product)
        {
            // 데이터 추가 수행
            this.DbAccess.ExecuteQueryNonQuery("DemoProduct.Insert", product);
        }
    }
}
