﻿<%@ Page Title="" Language="C#" MasterPageFile="~/WebPage.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="QuickStart.Web.Default" %>
<%@ Register Assembly="Ext.Net" Namespace="Ext.Net" TagPrefix="ext" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContentPlaceHolder" runat="server">
    <ext:ResourceManager ID="ResourceManager1" runat="server" />
    <div>
        <ext:GridPanel ID="GridPanel1" runat="server" 
            Region="Center" Title="Products" Icon="Lorry" Frame="true" Width="800">
            <Store>
                <ext:Store ID="Store1" runat="server" >
                    <Model>
                        <ext:Model ID="Model1" runat="server" IDProperty="ProductId">
                            <Fields>
                                <ext:ModelField Name="ProductId" />
                                <ext:ModelField Name="ProductName" />
                                <ext:ModelField Name="UnitPrice" Type="Float" />
                                <ext:ModelField Name="UnitsInStock" Type="Int"/>
                            </Fields>                                
                        </ext:Model>
                    </Model>
                </ext:Store>
            </Store>
            <ColumnModel ID="ColumnModel1" runat="server">
                <Columns>
                    <ext:Column ID="Column1" runat="server" DataIndex="ProductId" Text="Id">
                    </ext:Column>
                    <ext:Column ID="Column2" runat="server" DataIndex="ProductName" Text="Product Name" Flex="1">
                        <Editor>
                            <ext:TextField ID="TextField1" runat="server" />
                        </Editor>
                    </ext:Column>
                    <ext:Column ID="Column3" runat="server" DataIndex="UnitPrice" Text="Unit Price">
                        <Editor>
                            <ext:TextField ID="TextField2" runat="server" />
                        </Editor>
                    </ext:Column>
                    <ext:Column ID="Column4" runat="server" DataIndex="UnitsInStock" Text="Units in Stocks">
                        <Editor>
                            <ext:TextField ID="TextField3" runat="server" />
                        </Editor>
                    </ext:Column>
                </Columns>
            </ColumnModel>   
            <SelectionModel>
                <ext:RowSelectionModel ID="RowSelectionModel1" runat="server" Mode="Multi">
                    <Listeners>
                        <Select Handler="#{btnDelete}.enable();" />
                        <Deselect Handler="if (!#{GridPanel1}.selModel.hasSelection()) {
                                                #{btnDelete}.disable();
                                            }" />
                    </Listeners>
                </ext:RowSelectionModel>
            </SelectionModel>
            <Plugins>
                <ext:CellEditing ID="CellEditing1" runat="server" />
            </Plugins>                       
            <Buttons>
                <ext:Button ID="btnInsert" runat="server" Text="Insert" Icon="Add">
                    <Listeners>
                        <Click Handler="
                            if (#{GridPanel1}.hasSelection()) {
                                var record = #{GridPanel1}.getSelectionModel().getLastSelected();
                                var index = #{Store1}.indexOf(record);
                                #{Store1}.insert(index, {});
                            }
                            else {
                                #{Store1}.add({});
                            }
                            #{GridPanel1}.editingPlugin.startEditByPosition({row:0, column:0});" />
                    </Listeners>
                </ext:Button>            
                <ext:Button ID="btnDelete" runat="server" Text="Delete" Icon="Delete" Disabled="true">
                    <Listeners>
                        <Click Handler="#{GridPanel1}.deleteSelected();
                                        if (!#{GridPanel1}.hasSelection()) {
                                            #{btnDelete}.disable();
                                        }" />
                    </Listeners>
                </ext:Button>
                <ext:Button ID="btnSave" runat="server" Text="Save" Icon="Disk">
                     <DirectEvents>
                        <Click OnEvent="SaveClick">
                            <ExtraParams>
                                <ext:Parameter Name="data" Value="#{Store1}.getChangedData({skipIdForNewRecords : false})" Mode="Raw" Encode="true" />
                            </ExtraParams>
                            <Confirmation AutoDataBind="true" />
                        </Click>
                    </DirectEvents>
               </ext:Button>
                <ext:Button ID="btnClear" runat="server" Text="Clear" Icon="Cancel">
                    <Listeners>
                        <Click Handler="#{GridPanel1}.getSelectionModel().deselectAll();;
                                        if (!#{GridPanel1}.hasSelection()) {
                                            #{btnDelete}.disable();
                                        }" />
                    </Listeners>
                </ext:Button>
                <ext:Button ID="btnRefresh" runat="server" Text="Refresh" Icon="ArrowRefresh">
                    <Listeners>
                        <Click Handler="#{Store1}.load();" />
                    </Listeners>
                </ext:Button>
            </Buttons>
        </ext:GridPanel>
    </div>
</asp:Content>
