﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Ext.Net;
using QuickStart.Biz;
using TheOne.Data;
using TheOne.Data.SqlClient;

namespace QuickStart.Web
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (X.IsAjaxRequest == false)
            {
                // 웹 페이지 최초 오픈시 데이터 조회 및 바인딩
                BindData();
            }
        }

        // Save 버튼이 클릭되면 호출됨.
        protected void SaveClick(object sender, DirectEventArgs e)
        {
            // POST된 JSON 데이터로부터 Directionary 추출
            var products = new StoreDataHandler(e.ExtraParams["data"]).BatchObjectData<Dictionary<string, object>>();

            try
            {
                using (var biz = new BizComponent())
                {
                    biz.Save(products.Created, products.Updated, products.Deleted);
                }
                BindData();
                e.Success = true;
            }
            catch (Exception ex)
            {
                e.ErrorMessage = ex.Message;
                e.Success = false;
            }
        }

        private void BindData()
        {
            // 데이터 조회 및 바인딩 수행
            using (var dac = new DacComponent())
            {
                var ds = dac.GetDemoProduct();
                Store1.DataSource = ds.Tables[0];
                Store1.DataBind();
            }
        }
    }
}